MPQC 2.3.1

- Main Page
- Related Pages
- Classes
- Files

- Class List
- Class Hierarchy
- Class Members

Public Types | Public Member Functions
sc::MOIndexSpace Class Reference

Class MOIndexSpace describes a range of molecular orbitals or similar objects that are linear combinations of basis functions (e.g. More...

`#include <moindexspace.h>`

Inheritance diagram for sc::MOIndexSpace:

List of all members.

## Public Types

enum | IndexOrder { symmetry = 0, energy = 1, undefined = 2 }
| Describes the ordering of indices.

## Public Member Functions

| MOIndexSpace (StateIn &)
| MOIndexSpace (std::string name, const RefSCMatrix &full_coefs, const Ref< GaussianBasisSet > basis, const Ref< Integral > &integral, const vector< int > &offsets, const vector< int > &nmopi, IndexOrder moorder=symmetry, const RefDiagSCMatrix &evals=0)
| This function constructs an MOIndexSpace from (blocked) space full_coefs.
| MOIndexSpace (std::string name, const RefSCMatrix &full_coefs, const Ref< GaussianBasisSet > basis, const Ref< Integral > &integral, const RefDiagSCMatrix &evals, int nfzc, int nfzv, IndexOrder moorder=energy)
| This constructor should be used when the MOIndexSpace object is a subspace of a full orbital space.
| MOIndexSpace (std::string name, const RefSCMatrix &full_coefs, const Ref< GaussianBasisSet > basis, const Ref< Integral > &integral)
| This constructor should be used when the MOIndexSpace object is the full orbital space.
| MOIndexSpace (std::string name, const Ref< MOIndexSpace > &orig_space, const RefSCMatrix &new_coefs, const Ref< GaussianBasisSet > &new_basis)
| This constructor is a true hack introduced because I have no idea how to construct what I need.
void | save_data_state (StateOut &)
| Save the base classes (with save_data_state) and the members in the same order that the StateIn CTOR initializes them.
const std::string | name () const
| Returns the name of this MOIndexSpace.
const Ref< GaussianBasisSet > | basis () const
| Returns the AO basis set.
Ref< Integral > | integral () const
| Returns the integral factory used to instantiate the coefficient matrix.
const RefSCMatrix | coefs () const
| Returns the coefficient matrix.
const RefDiagSCMatrix | evals () const
| Returns the "eigenvalues" matrix.
vector< int > | mosym () const
| Returns the orbital symmetry array.
IndexOrder | moorder () const
| Returns the order of the orbitals.
int | rank () const
| Returns the rank of the space.
int | full_rank () const
| Returns the rank of the full space.
int | nblocks () const
| Returns the number of blocks.
vector< int > | nmo () const
| Returns the number of orbitals in each block.
vector< int > | offsets () const
| Returns the full-space index of the first orbital in each block.
int | to_full_space (const int i) const
| Returns the full-space index.
size_t | memory_in_use () const
| Returns how much "significant" (i.e. O^2) memory this object uses.
void | print (std::ostream &o=ExEnv::out0()) const
| Prints out this.
void | print_summary (std::ostream &os) const
| Produces a short summary.

## Detailed Description

Class MOIndexSpace describes a range of molecular orbitals or similar objects that are linear combinations of basis functions (e.g.

atomic orbitals). In general, such sets are subspaces of a full space of orbitals supported by the given basis. Orbitals can be symmetry-blocked, ordered by energy, etc. Examples of sets that can be described using MOIndexSpace are occupied MOs and virtual MOs.

## Constructor & Destructor Documentation

sc::MOIndexSpace::MOIndexSpace | ( | std::string | name,
|  | const RefSCMatrix & | full_coefs,
|  | const Ref< GaussianBasisSet > | basis,
|  | const Ref< Integral > & | integral,
|  | const vector< int > & | offsets,
|  | const vector< int > & | nmopi,
|  | IndexOrder | moorder = `symmetry`,
|  | const RefDiagSCMatrix & | evals = `0`
| ) |  |

This function constructs an MOIndexSpace from (blocked) space full_coefs.

Block i will contain vectors [ offsets[i], offsets[i]+nmopi[i]-1 ] . By default, the space maintains the same blocked structure and the same order within blocks as the original space (moorder=symmetry). If moorder=energy and eigenvalues evals are provided, then all vectors will be put in one block and sorted according to ascending evals.

Parameters:

  name | -- the name of this MOIndexSpace
  full_coefs | -- symmetry-blocked transformation coefficient matrix (AO by MO) for the full space
  basis | -- basis set
  integral | -- integral factory
  offsets | -- block offsets
  nmopi | -- new block sizes
  moorder | -- specifies new ordering of vectors
  evals | -- used to sort the vectors

sc::MOIndexSpace::MOIndexSpace | ( | std::string | name,
|  | const RefSCMatrix & | full_coefs,
|  | const Ref< GaussianBasisSet > | basis,
|  | const Ref< Integral > & | integral,
|  | const RefDiagSCMatrix & | evals,
|  | int | nfzc,
|  | int | nfzv,
|  | IndexOrder | moorder = `energy`
| ) |  |

This constructor should be used when the MOIndexSpace object is a subspace of a full orbital space.

Similarly to the previous constructor, it constructs an MOIndexSpace object using a symmetry-blocked transformation coefficient matrix (AO by MO) for the full space, basis set, "eigenvalues" and the number of orbitals with lowest (nfzc) and highest (nfzv) eigenvalues to be dropped. The orbitals in the constructed space are ordered by energy.

sc::MOIndexSpace::MOIndexSpace | ( | std::string | name,
|  | const RefSCMatrix & | full_coefs,
|  | const Ref< GaussianBasisSet > | basis,
|  | const Ref< Integral > & | integral
| ) |  |

This constructor should be used when the MOIndexSpace object is the full orbital space.

The orbitals will be symmetry-blocked.

sc::MOIndexSpace::MOIndexSpace | ( | std::string | name,
|  | const Ref< MOIndexSpace > & | orig_space,
|  | const RefSCMatrix & | new_coefs,
|  | const Ref< GaussianBasisSet > & | new_basis
| ) |  |

This constructor is a true hack introduced because I have no idea how to construct what I need.

It will copy orig_space but replace it's coefs with new_coefs, and its basis with new_basis.

## Member Function Documentation

void sc::MOIndexSpace::save_data_state | ( | StateOut & |  | ) | `[virtual]`

Save the base classes (with save_data_state) and the members in the same order that the StateIn CTOR initializes them.

This must be implemented by the derived class if the class has data.

Reimplemented from sc::SavableState.

The documentation for this class was generated from the following file:

- moindexspace.h